package edu.nyu.scps.file;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;

import android.app.Activity;
import android.content.Context;
import android.os.Bundle;
import android.util.Log;
import android.widget.TextView;

public class FileActivity extends Activity {
	private static final String TAG = "FileActivity";
	/** Called when the activity is first created. */
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.main);

		TextView textView = (TextView)findViewById(R.id.textView);
		if (textView == null) {
			Log.e(TAG, "couldn't find textView");
		}
		
		textView.setText("Files directory is\n" + getFilesDir() + "\n\n");
		textView.append("Cache directory is\n" + getCacheDir() + "\n\n");

		//Cretae a new subdirectory.
		File subdir = getDir("subdir", MODE_PRIVATE);
		textView.append("Subdirectory is\n" + subdir + "\n\n");
/*
		if (!subdir.delete()) {
			textView.append("could not delete " + subdir + ".\n");
		}
*/

		String filename = "filename.txt";

		try {
			//MODE_PRIVATE: File can be acessed only by this app
			//and other apps with the same user ID
			FileOutputStream fileOutputStream =
				openFileOutput(filename, Context.MODE_PRIVATE);

			fileOutputStream.write("hello\n".getBytes());
			fileOutputStream.close();
			
			File file = new File(getFilesDir(), filename);
			int n = (int)file.length();
			textView.append(filename + " contains " + n + " byte(s).\n");
			
			FileInputStream fileInputStream = openFileInput(filename);
			byte[] buffer = new byte[n];
			int i = fileInputStream.read(buffer, 0, n);
			textView.append("Read " + i + " byte(s) from " + filename + ":\n");
			String s = new String(buffer);
			textView.append(s + "\n\n");
			fileInputStream.close();
		} catch(Exception e) {
			Log.e(TAG, e.getMessage());
		}

		//Display the names of this app's files.

		String[] filenames = fileList();
		textView.append(filenames.length + " file(s):\n");
		for (int i = 0; i < filenames.length; ++i) {
			textView.append((i + 1) + " " + filenames[i] + "\n");
		}

/*		
		if (!deleteFile(filename)) {
			textView.append("could not delete " + filename + ".\n");
		}
*/
		textView.invalidate();	//redraw the textView
	}
}